<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE videocollection [
  <!ENTITY ndash "&#8211;">
  <!ENTITY mdash "&#8212;">
]>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
	xmlns:gslib="http://www.greenstone.org/skinning"
	xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"	
	extension-element-prefixes="java util"
	exclude-result-prefixes="java util">


  <xsl:template name="coll-description">
    <gsf:script src="sites/{$site_name}/collect/{$collName}/js/jquery.show-more.js"/>

      <div id="about-desc">
	  <h2>Introduction</h2>
	  <!--
	  <p style="padding-bottom: 10px;">
	    The <a href="https://eurovision.tv">Eurovision Song
	    Contest</a> is a live-broadcast televised event that
	    was first held in 1956 featuring artists singing original songs from
	    7 countries.  Since then it has grown into an event involving
	    over 40 countries, and streamed all around the world. ...
	    
	  </p>
	  -->
	  
	  <p style="padding-bottom: 10px;">
	    <i style="padding-right:6px;">A help to shore up a post war Europe in 1956 it
	    all began, where there were only seven countries and one
	    camera man!</i>
	  </p>
	  <p>
	    The <a href="https://eurovision.tv">Eurovision Song
	    Contest</a> is a long-running, live-broadcast televised multi-national
	    competition with a collaborative mission, not dissimilar
	    in spirit to the Olympics.
	    The contest has grown significantly from
	    that modest start with 7 countries (and one cameraman),
	    with over 40 countries competing these days—Australia
	    even takes part now, through a specially
	    arranged invitation. It's an annual celebration of
	    European culture and the highlight of many people's
	    year.
	  </p>

	  <div id="about-show-more">
	    <p>	    
	      At Eurovision there is no division because wherever
	      you come from Eurovision is home. The Eurovision song
	      contest is widely known as a safe space for LGBTQIA+
	      people and a platform for free expression. For example
	      trans-woman
	      <a href="https://en.wikipedia.org/wiki/Dana_International">Dana International</a>
	      won as far back as 1998.
	      There have been songs in many different languages over the
	      years, although most are in English these days. This
	      doesn't matter, however, because music is a language we all
	      know how to speak.
	    </p>
	    <p>	    
	      In its latest incarnation, after
	      all the performances are over, artists wait
	      nervously as via live television link-ups the show's hosts visit each
	      of the 40+ countries in turn collecting all points cast
	      by the country appointed juries.  This includes
	      the all important top score that can be cast, 12 points
	      (douze points!), a double-increment up from the
	      10 points awarded to the song a country ranks second,
	      followed by 8, 7, 6 … 1 points awarded.
	      With over 20 countries competing in a final, this means
	      that not all performers gets points from that country.
	      Next comes the &quot;the popular vote&quot;
	      where fans, still grouped by country, have
	      the votes they cast by phone, SMS or the Eurovision app
	      tallied and mapped into the same format of 12 points for 1st
	      place, and so on.
	      This all culminates in a new winner being crowned, with
	      the competition typically being hosted the following year
	      in that country. 
	    </p>
	  </div>
	  <gsf:script>
	    $('#about-show-more').showMore({
	        minheight: 0,
		buttontxtmore:"show more ...",
		buttontxtless:"... show less"
	      });
	  </gsf:script>

	  
	  <h2>Features of this Website</h2>

	  <p>	    
	    This (unofficial) website has been developed by a small
	    team of dedicated Digital Library researchers who also
	    happen to be <i>huge</i> fans of Eurovision.  We wish to
	    share our love for the competition, and at the same time
	    demonstrate what is possible when—harnessing some of that
	    passion!—the techniques of
	    <a href="https://en.wikipedia.org/wiki/Linked_data">Linked
	    Open Data</a> are applied
	    to the Open Source
	    <a href="https://www.greenstone.org">Greenstone3</a>
	    Digital Library platform.  For the technically interested
	    see the
	    <a href="{$library_name}/collection/{$collName}/page/about#it-all-started-with">
	      <i style="padding-right: 6px;">It All Started with a Little <strike>Sparkle</strike>SPARQL</i></a>
	      below for details about how the digital library was formed.
	  </p>

	  <!--
	  <p>
	    For those who want to jump right in and access information about, as well as see and hear some of the past performances,
	    we suggest you
	    start by exploring the assembled information through
	    the browsing tabs, such as
	    <a href="{$library_name}/collection/{$collName}/browse/CL3">browse by countries</a>
	    if you want (for instance) to reminisce about songs your country have entered in the past, or
	    <a href="{$library_name}/collection/{$collName}/browse/CL4">browse by years</a> if
	    you are curious about who were the countries competing in that inaugural year of 1956.
	    Alternatively, use the quick-search box to query the DL collection for a term that you sparks
	    interest, such as
	    <a href="{$library_name}/collection/{$collName}/search/TextQuery?qs=1&amp;rt=rd&amp;s1.level=Doc&amp;startPage=1&amp;s1.query=love&amp;s1.index=ZZ">love</a>
	    and
	    <a href="{$library_name}/collection/{$collName}/search/TextQuery?qs=1&amp;rt=rd&amp;s1.level=Doc&amp;startPage=1&amp;s1.query=amore&amp;s1.index=ZZ">amore</a>,
	    or maybe something more frivolous such as
	    <a href="{$library_name}/collection/{$collName}/search/TextQuery?qs=1&amp;rt=rd&amp;s1.level=Doc&amp;startPage=1&amp;s1.query=la&amp;s1.index=ZZ">la</a>.
	    
	  </p>
-->

	  <p>
	    For those who want to jump right in and access information about, as well as see and hear some of the past performances,
	    we suggest you
	    start by exploring the assembled information through
	    the browsing tabs.  For example:
	    <ul>
	      <li><a href="{$library_name}/collection/{$collName}/browse/CL3">Browse by countries</a>
	      if you want (for instance) to reminisce about songs your country have entered in the past; or</li>
	      <li><a href="{$library_name}/collection/{$collName}/browse/CL4">Browse by years</a> if
	      you are curious about who were the countries competing in that inaugural year of 1956.</li>
	    </ul>
	  </p>
	  <p>
	    Alternatively, use the quick-search box to query the DL collection for a term that sparks
	    your interest. For example:
	    <ul>
	      <li>
		<a href="{$library_name}/collection/{$collName}/search/TextQuery?qs=1&amp;rt=rd&amp;s1.level=Doc&amp;startPage=1&amp;s1.query=love&amp;s1.index=ZZ">love</a>
		and
		<a href="{$library_name}/collection/{$collName}/search/TextQuery?qs=1&amp;rt=rd&amp;s1.level=Doc&amp;startPage=1&amp;s1.query=amore&amp;s1.index=ZZ">amore</a>,
		or maybe something more frivolous such as
		<a href="{$library_name}/collection/{$collName}/search/TextQuery?qs=1&amp;rt=rd&amp;s1.level=Doc&amp;startPage=1&amp;s1.query=la&amp;s1.index=ZZ">la</a>.
	      </li>
	    </ul>	    
	  </p>
	  
	  <!-- endpoint -->
	  
	  <xsl:variable name="graphURI"><xsl:value-of select="$sparqlGraphBasePrefix"/><xsl:value-of select="$siteURL"/><xsl:value-of select="$library_name"/>/collection/<xsl:value-of select="$collName"/></xsl:variable>
	  <!--
	  <xsl:variable name="graphURI"><xsl:value-of select="$sparqlGraphBasePrefix"/><xsl:value-of select="$siteURL"/>eurovision-dev-library/collection/<xsl:value-of select="$collName"/></xsl:variable>	  
	  -->
	  <!-- 
	       Kudos to:
	        https://byabbe.se/2020/09/17/getting-random-results-in-sparql
	  -->
	  <div id="select-random-entrant-sparqlquery" style="display: none;">
PREFIX rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt;
PREFIX xsd: &lt;http://www.w3.org/2001/XMLSchema#&gt;
PREFIX gsdlextracted: &lt;http://greenstone.org/gsdlextracted#&gt;

SELECT ?random ?esc_entrant_uri ?country ?year ?flag_img WHERE {
  GRAPH &lt;<xsl:value-of select="$graphURI"/>&gt;  {
    ?esc_entrant_uri gsdlextracted:Year ?year.
    ?esc_entrant_uri gsdlextracted:Country ?country.
    ?esc_entrant_uri gsdlextracted:FlagImg ?flag_img.
    BIND(SHA512(CONCAT(STR(RAND()), STR(?esc_entrant_uri))) AS ?random).
  }
}
ORDER BY ?random
	  </div>
	  <div id="select-random-entrant-div" >
	    Or how about picking a song at random:
	    <ul id="select-random-entrant-ul" style="display: none;">
	      <li>
		<div id="select-random-entrant-item" style="display: none;">
		  <a id="select-random-entrant-a">
		    <span id="select-random-entrant-span" style="display: inline-block; padding: 6px;"></span>
		  </a>
		  <span class="page ssq" style="margin-left: 6px;">
		    <button type="button" onclick="ajaxpick_random_entrant()">Pick again</button>
		  </span>
		</div>
	      </li>
	    </ul>
	  </div>
	  <gsf:script>
	    $(document).ready(function() { ajaxpick_random_entrant() });
	  </gsf:script>

	  <h2>Data Analysis and Visualization</h2>


	  <!-- bespoke visualization done by getting SPARQL data first, and then
	       feeding into Google Charts (Treemap) to get better control -->
	  <div id="treemap-voting-for-winner-2021-sparqlquery" style="display: none;">
PREFIX rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt;
PREFIX xsd: &lt;http://www.w3.org/2001/XMLSchema#&gt;
PREFIX gsdlextracted: &lt;http://greenstone.org/gsdlextracted#&gt;

SELECT  (?j_country AS ?jt_vote_from_country) ?to_country ?total_vote_int ?diff_vote_int ?j_vote_int ?t_vote_int 
WHERE {
{
  GRAPH &lt;<xsl:value-of select="$graphURI"/>&gt;  {

  ?esc_entrant_uri gsdlextracted:Year ?year
      FILTER(xsd:integer(?year) = 2021).

    ?esc_entrant_uri ?gsdlextracted_j_country_uri ?j_vote.
    BIND(STRENDS(str(?gsdlextracted_j_country_uri),"-J") AS ?is_j_vote).
    FILTER (?is_j_vote).
    BIND(REPLACE(str(?gsdlextracted_j_country_uri), ".*#(.*?)-J$", "$1") AS ?j_country).

    ?esc_entrant_uri ?gsdlextracted_t_country_uri ?t_vote.
    BIND(STRENDS(str(?gsdlextracted_t_country_uri),"-T") AS ?is_t_vote).
    FILTER (?is_t_vote).
    BIND(REPLACE(str(?gsdlextracted_t_country_uri), ".*#(.*?)-T$", "$1") AS ?t_country).

    FILTER(?j_country = ?t_country).

    BIND(xsd:integer(?j_vote) AS ?j_vote_int).
    BIND(xsd:integer(?t_vote) AS ?t_vote_int).

    BIND((?t_vote_int + ?j_vote_int) AS ?total_vote_int).
    BIND((?t_vote_int - ?j_vote_int) AS ?diff_vote_int).

    ?esc_entrant_uri gsdlextracted:Country ?to_country.

    FILTER(?to_country = "Italy").
      
  }
 }
 UNION { 
  VALUES (?j_country ?to_country ?total_vote_int ?diff_vote_int ?j_vote_int ?t_vote_int ) {
     ( "Italy"  UNDEF 0 0 0 0 )
  }
 }
}
	  </div>
	  <style>
	    .google-visualization-tooltip {
	       z-index: 1000;
	       }
	     .goog-tooltip {
	       z-index: 1000;
	     }
	  </style>
	  <div id="treemap-voting-for-winner-2021-divchart" style="width: 900px; height: 600px; background-color: #fff; margin-left: auto; margin-right: auto; margin-bottom: 12px;">">
	    Loading ...
	  </div>

	  <gsf:script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"/>
	  <gsf:script>
	    $(document).ready(function() { ajax_display_treemap_winner_2021() });
	  </gsf:script>
	  
	  <gsf:script src="ext/jena/sgvizler2/sgvizler2.js"/>

	  <!--
	  <gsf:script>
	      $(document).ready(	
                function() {
	      
		  // Exaple triple
		  // "s": { "type": "uri" , "value": "http://127.0.0.1:8383/greenstone3/library/collection/eurovision/document/HASH0191e9cc7bfdf14743472257s10" } ,
		  // "p": { "type": "uri" , "value": "gsdlextracted:Country" } ,
		  // "o": { "type": "literal" , "value": "United Kingdom" }

		  sgvizler2.containerDraw('sgvizler2-country-count');				  
		}
	      );
	  </gsf:script>
	  -->

	  <!-- endpoint -->
	  <!--
	  <div id="sgvizler2-country-count"
	       data-sgvizler-endpoint="//{$sparqlEndpointHostAndOptPort}{$sparqlEndpointPrefix3}/greenstone/query"
	       data-sgvizler-chart="google.visualization.BarChart"
	       data-sgvizler-chart-options="title=Number of Songs from each Country|legend.position=none|height=900|chartArea.height=840|fontSize=11"
	       data-sgvizler-log="2"
	       style="width:900px; height:300px; margin-left: auto; margin-right: auto; overflow-y: scroll; overflow-x: hidden;">
	       <xsl:attribute name="data-sgvizler-query">
		 PREFIX rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt;
		 PREFIX gsdlextracted: &lt;http://greenstone.org/gsdlextracted#&gt;

		 SELECT ?country (COUNT(?country) AS ?freqCount)		 
		 WHERE {
		   GRAPH &lt;<xsl:value-of select="$graphURI"/>&gt;  {
		       { 
			 SELECT DISTINCT ?country ?year WHERE {
			     ?s gsdlextracted:Country ?country.
			     ?s gsdlextracted:Year ?year.
			 } ORDER BY ?country ?year
		       }
		     }
		 }
		 GROUP BY ?country ORDER BY ASC(?country)
	       </xsl:attribute>
	       <xsl:text> Loading ...</xsl:text>
	  </div>
	  -->
	  <!--
	  <p style="padding-top: 10px;">
	    All the metadata in the digital library is simultaneously
	    published as linked data, meaning it is possible to
	    extract and analyze the data contained here in a variety
	    of ways.  To aid in such analysis we have
	    added in a data visualization layer to the digital
	    library.  This is how the bar-graph above has been
	    created, which shows how many times each country has
	    competed, alphabetically sorted.
	  </p>
	  -->
	  <p>
	    For more visualization, see our:
	    <ul>
	      <li>
		<a href="{$library_name}/collection/{$collName}/page/sgvizler">Visualizer page</a>
	      </li>
	    </ul>
	  </p>
	  <p>
	    where we provide samples you can try out to give you an idea of
	    the sorts of visualization that can be produced. More
	    importantly, these samples are editable so you are free to
	    change them however you wish.  On the visualization page
	    you'll find a sample that shows you how often different
	    countries have won Eurovision, but perhaps you'd like to
	    find out who has lost the most often?  We also provide a
	    sample dataflow visualization of jury voting patterns over
	    the last decade, which makes for interesting viewing!
	    Adjust the values used to discover how this compares
	    with other time periods.
	  </p>

	  <div id="viz-show-more" style="margin-bottom: 10px;">

	    <p>
	      In addition to the visualizer, through the:
	      <ul>
		<li>
		  <a href="{$library_name}/collection/{$collName}/page/sparql">Data Analysis page</a>
		</li>
	      </ul>
	      you will find a set of samples you can test-drive to give you an idea of the
	      sorts of raw data analysis that can be done.  The syntax used is called
	      <a href="https://en.wikipedia.org/wiki/SPARQL" target="_blank">SPARQL</a> (pronounced &quot;sparkle&quot;).  If you are unfamiliar
	      with this syntax, there are a variety of tutorials available online where you can learn about query language, such as
	      the one done by <a href="https://jena.apache.org/tutorials/sparql.html" target="_blank">Apache Jena</a>, an Open Source
	      initiative that provides a variety of Semantic Web and Linked Data tools.
	      As before, these samples are editable so you are free to
	      change them however you wish to adjust the analysis undertaken, or once you're mastered the
	      query syntax, develop completely original forms of
	      analysis.
	  </p>

	  
	  <p>
	    We suggest starting with viewing <a href="{$library_name}/collection/{$collName}/page/sgvizler">sample visualizations</a> to see what's possible,
	    and making minor edits to that to adjust what is visualized.
	    Then, if you want to start visualizing the data in a more substantially different way
	    or else export the data for more detailed analysis under your own control,
	    switch to the <a href="{$library_name}/collection/{$collName}/page/sparql">SPARQL-based data analysis</a> page to ensure the underlying
	    data retrieved is as you intended.  Then take the newly developed SPARQL query back to the visualizer page, and through the
	    additional text-input fields provided there, develop the visualization.

	  </p>

	  </div>

	  <gsf:script>
	    $('#viz-show-more').showMore({
	        minheight: 0,
		buttontxtmore:"show more ...",
		buttontxtless:"... show less"
	      });
	  </gsf:script>

<!--
	  <p>	    
	    If you'd like to dig into the data behind this Digital Library collection, this can be done directly
	    using the <a href="{$library_name}/collection/{$collName}/page/sparql">SPARQL Query interface</a>.
	    This is a good place to go to see what sort of data is being stored, and we provide some sample
	    queries to get you going.  But if you like to see the data presented more visually, we suggest
	    you try out the <a href="{$library_name}/collection/{$collName}/page/sgvizler">SGVizler page</a>,
	    which takes things to the next level, using pie-charts, histograms and other forms of
	    visualization to present the data.	    
	  </p>

-->

	  <h2 id="it-all-started-with">It All Started with a Little <strike>Sparkle</strike>SPARQL</h2>
	  

	  <p>
	    In terms of how this collection was developed using the
	    Greenstone3 Digital Library (DL) architecture, we are
	    being a touch irreverent to say <i>it all started with a
	    little SPARQL</i>.
	    It is certainly true to say that, operationally, the DL
	    was created using SPARQL query that draws down JSON
	    records from
	    <a href="https://dbpedia.org" target="_blank">DBPedia</a>	    
	    about all the different entrants in the Eurovision.  This
	    is then ingested into Greenstone using its document- and
	    metadata-processing pipeline: expand through the <i>show
	    more ...</i> button below to see the actual query.
	    But in truth, our starting point of the SPARQL query is
	    only possible due to the Herculean efforts of the
	    contributors to the Wikipedia pages about
	    the Eurovision Song Contest, and following on from
	    that the endeavors of the DBPedia project to
	    transform a substantial portion of that information
	    into machine-readable linked data.
	  </p>

	  <p>
	    Continuing the technical development of the DL,
	    to the DBpedia extracted content, we then added in voting metadata—again
	    using the Greenstone document- and metadata- processing
	    pipeline—this time in the form of CSV-based spreadsheet derived from the
	    <a href="https://www.kaggle.com/datagraver/eurovision-song-contest-scores-19752019" target="_blank">Kaggle Eurovision Voting dataset 1975-2019</a>.
	  </p>
	  

	  <div id="dl-tech-show-more">
	    <p>
	      Here's the SPARQL query that retrieves, for every year
	      Eurovision has been held, the countries that took part.
	      At under 20 lines of code, we think it's pretty awesome!
	      The information retrieved includes the country, year,
	      title of the song, and name of the entrant (the
	      act/artist), amongst other things.  All useful core
	      information to seed the digital library collection.  As
	      the 2020 Eurovision event did not run due to the
	      Covid-19 Pandemic, and (at the time of writing the 2021
	      is yet to occur), we have opted to filter the matches
	      returned to be prior to 2020.
	    </p>
<!--
#    bind( REPLACE(str(?country_in_year), ".*(\\d{4})", "$1") AS ?year).

PREFIX rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#&gt;
xsd:
skos:
prov:

dbc:
dbp:

dct:
-->	    
	    <pre style="background-color: #fff; color: #000; padding: 12px; margin-right: 6px;">
SELECT ?countries_in_esc_by_year ?country_in_year (?year AS ?Year) (?country AS ?Country) ?entrant (?entrant_label AS ?Creator) ?song (?song_label AS ?Title) (?was_derived_from AS ?WikipediaURL)
WHERE {
    ?countries_in_esc_by_year skos:broader dbc:Countries_in_the_Eurovision_Song_Contest_by_year.

    ?country_in_year dct:subject ?countries_in_esc_by_year.
    ?country_in_year dbp:year ?year.
    FILTER ( xsd:integer(?year) &lt; 2020).

    ?country_in_year dbp:country ?country.

    ?country_in_year dbp:entrant ?entrant.
    ?entrant rdfs:label ?entrant_label
      FILTER (lang(?entrant_label) = 'en').

    ?country_in_year dbp:song ?song.
    ?song rdfs:label ?song_label
      FILTER (lang(?song_label) = 'en').

    OPTIONAL {
      ?song prov:wasDerivedFrom ?was_derived_from
    }
}
ORDER BY DESC(?countries_in_esc_by_year)
	    </pre>

	    <p>
	      You can try this query out yourself if you like.  Select the entirety of the SPARQL query
	      in the above text box, and press <i>Control-C</i> to place it in your Copy-buffer.
	      Next visit the DBPedia SPARQL Endpoint given below, and in the main text box of the page
	      that appears, press <i>Control-V</i>
	      to paste in your SPARQL query. Finally, click on the <i>Execute Query</i> button
	      to initiate the search.
	      <ul>
		  <li>
		    <a href="https://dbpedia.org/sparql/" target="_blank">DBpedia's SPARQL endpoint</a>
		  </li>
	      </ul>
	    </p>
	    <p>
	      Through the SPARQL Endpoint you can change the output format that is used to, for example, JSON or Turtle.
	      For convenience, if you are just interested in seeing what the outcome of running the query is, displayed as a web page:
	      <ul>
		<li>
		  <a href="https://dbpedia.org/sparql?default-graph-uri=http%3A%2F%2Fdbpedia.org&amp;query=SELECT+%3Fcountries_in_esc_by_year+%3Fcountry_in_year+%3Fyear+as+%3FYear+%3Fcountry+as+%3FCountry+%3Fentrant+%3Fentrant_label+as+%3FCreator+%3Fsong+%3Fsong_label+as+%3FTitle+%3Fwas_derived_from+as+%3FWikipediaURL%0D%0AWHERE+%7B%0D%0A++++%3Fcountries_in_esc_by_year+skos%3Abroader+dbc%3ACountries_in_the_Eurovision_Song_Contest_by_year.%0D%0A%0D%0A++++%3Fcountry_in_year+dct%3Asubject+%3Fcountries_in_esc_by_year.%0D%0A++++bind%28+REPLACE%28str%28%3Fcountry_in_year%29%2C+%22.*%28%5C%5Cd%7B4%7D%29%22%2C+%22%241%22%29+as+%3Fyear%29.%0D%0A++++FILTER+%28+xsd%3Ainteger%28%3Fyear%29+%3C+2020%29.%0D%0A%0D%0A++++%3Fcountry_in_year+dbp%3Acountry+%3Fcountry.%0D%0A%0D%0A++++%3Fcountry_in_year+dbp%3Aentrant+%3Fentrant.%0D%0A++++%3Fentrant+rdfs%3Alabel+%3Fentrant_label%0D%0A++++++FILTER+%28lang%28%3Fentrant_label%29+%3D+%27en%27%29.%0D%0A%0D%0A++++%3Fcountry_in_year+dbp%3Asong+%3Fsong.%0D%0A++++%3Fsong+rdfs%3Alabel+%3Fsong_label%0D%0A++++++FILTER+%28lang%28%3Fsong_label%29+%3D+%27en%27%29.%0D%0A%0D%0A++++OPTIONAL+%7B%0D%0A++++++%3Fsong+prov%3AwasDerivedFrom+%3Fwas_derived_from%0D%0A++++%7D%0D%0A%7D%0D%0AORDER+BY+DESC%28%3Fcountries_in_esc_by_year%29&amp;format=text%2Fhtml&amp;timeout=30000&amp;signal_void=on&amp;signal_unconnected=on" target="_blank">Click here to run the query directly</a>
		</li>
	      </ul>
	    </p>

	    <h2>Triplestore Errata</h2>

	    <p>
	      The above SPARQL query is a good starting point to
	      extract all the Eurovision entries over the years,
	      however a more careful study of the returned results
	      revealed a few complications that needed to be
	      addressed. One issue stems from the fact that in its
	      inaugural year, countries were allowed to send two
	      entries each.  For 1956, for every URI representing a
	      country in that year there are two title and two
	      entrants represented.  As initially expressed, the
	      SPARQL query does not cater for this circumstance and
	      results in 2 x 2 = 4 combinations of artist and title
	      per song.
	    </p>
	    <p>
	      The way to address this is to include an additional
	      constraint that ensures that the URI representing
	      <i>?song</i> includes the relationship <i>dbp:artist</i>
	      for <i>?entrant</i>, effectively locking in to the
	      artist that performed that particular song.  Studying
	      the result of this change, however, showed up a more
	      wide-reaching problem which was that not all the
	      <i>?country_year</i> URI entries expressed relationships
	      to songs and artists that were themselves URI: sometimes
	      they were represented as a string literal, meaning the
	      added constraint would fail, and reject entirely the
	      details about a country's entry in that
	      year. Compounding this, we also saw that some of the
	      processing work by DBPedia to turn the manually curated
	      information in Wikipedia into machine-readable form
	      erroneously handled the formation of some of the song
	      titles and artists.
	    </p>
	    <p>
	      Given that the erroneous entries were strings (even
	      integer numbers at times!) and not URI gave us a way in
	      to see how wide-spread the problem was.  Using adapted
	      versions of the the main SPARQL query we had formulated,
	      we were able to produce lists of the affected entries.
	      The lists are available here through the following
	      links:
	      <ul>
		<li>
		  <a target="_blank" href="sites/{$site_name}/collect/{$collName}/prepare/problem-lod-lists/dbpedia-problem-songs.html">Problem Songs (titles are literals not URIs/IRIs)</a>
		</li>
		<li>
		  <a target="_blank" href="sites/{$site_name}/collect/{$collName}/prepare/problem-lod-lists/dbpedia-problem-entrants.html">Problem Entrants (artists are literals not URIs/IRIs)</a>
		</li>
	      </ul>
	    </p>

	    <p>
	      The generation of these lists also provided the key to
	      the approach we used to compensate for the complications
	      these issues introduced.  Skipping ahead slightly to the
	      formation of the Digital Library collection with
	      Greenstone3, we make use of this software architecture's
	      Triplestore Extension, which means that in addition to
	      the main DL and Open Archive Initiative (OAI) server
	      endpoints, there is also a triplestore backend.  While
	      the triplestore extension was designed to provide SPARQL
	      access to the metadata and document content of the DL
	      collections, its existence means we can include in it a
	      graph that represents the necessary errata information
	      we need to &quot;course correct&quot; the SPARQL query
	      to perform how it is intended.
	    </p>
	    
	    <p>
	      This does admittedly complicate the expression of the
	      query, but the additions are manageable.  The expanded
	      query makes use of SPARQL's federated search feature:
	      the query starts as before with the retrieval of triples
	      from the DBPedia endpoint; based on resolved values of
	      entities such as <i>?country_year</i> and <i>?song</i>,
	      it then optionally retrieves matching items from the DL
	      SPARQL endpoint.  The final step is to use a conditional
	      clause (if-statement) to test to see if the DBpedia
	      version of the song is a literal, and if it is and if
	      there is a bound value for the DL retrieved one, then it
	      selects that one in preference.
	    </p>

	    <p>
	      The DBpedia SPARQL endpoint doesn't allow for federated
	      queries, and so we initiate the SPARQL queries through
	      the DLs SPARQL endpoint, using SERVICE blocks to specify
	      the parts of the query that are run on the DBpedia endpoint.
	      <ul>
		<li>
		  <a href="{$library_name}/collection/{$collName}/page/sparql">DL's (local) SPARQL endpoint</a>
		</li>
	      </ul>
	    </p>
	    
	    <h3>Adding in Voting Metadata</h3>

	    <p>
	      To fulfill our vision of developing this DL collection
	      as a rich resource through which people can explore the
	      phenomenon we went looking for voting data that was
	      available in a machine-readable format.
	      We found data compiled through a manual curation process
	      about how countries have voted going back to 1975 is available through the
	      <a href="https://www.kaggle.com/datagraver/eurovision-song-contest-scores-19752019">Kaggle website as an Excel spreadsheet</a>.
	    </p>
	    <p>
	      To incorporate this as metadata into the DL, we wrote
	      some Python code to transform the data into the internal
	      serialized metadata format used by Greenstone.  Prior to
	      this project, the only serialized form for this was XML,
	      which is processed by the MetadataXML plugin.  As it was
	      more convenient to generate JSON from our Python code,
	      we took the step of adding in a new plugin to
	      Greenstone3: MetadataJSON.
	    </p>

	    <h3>Page Scraping</h3>

	    <p>
      	      Despite our best intentions work solely with
      	      machine-readable data—primarily as you have seen in the
      	      form of Linked Open Data, but also utilizing a
      	      spreadsheet of voting data—to form the Eurovision DL,
	      in looking to expand the metadata in the DL to cover
	      details concerning the draw position of acts, and their
	      overall placing, we have resorted to page-scraping
	      content from Wikipedia itself.  This was because such
	      information was not part of the entity extraction
	      process that occurs when Wikipedia is mapped to DBpedia.
	    </p>

	    <p>
	      A review of Wikipedia article pages about the event in
	      any given year showed these pages to be especially well
	      curated, and included a table in each that listed the
	      information we sought.  While there was some variation
	      in how this table was expressed in HTML, with a
	      considerably portion of the heavy lifting being done by
	      the Python library BeautifulSoup4, it was not too
	      complex a task to develop a program that extracted this
	      information and turned it into the newly developed
	      Greenstone JSON metadata format.
	    </p>
	      
	    <h3>Patching in Missing Data</h3>

	    
	    <p>
	      Another difficulty we have encountered is that
	      not every country who had an entry in Eurovision
	      in a given year has its own standalone article page.
	      This leads to missing entries in the category
	      page for the contest in a given year, which is
	      problematic to us, because it is this category
	      information that we draw upon in our SPARQL query
	      to populate the DL with all the acts.
	    </p>
	    <p>
	      The information about all the countries competing
	      in a given year does, however, appear in the
	      article page for the contest in that year.  In fact
	      it's in the same table we targeted to extract out
	      the draw position and placement.  We therefore
	      wrote a further page-scraping program to compare
	      the countries in that table with the countries
	      listed on the category page for the contest in
	      that year.  For any entries we find in the
	      table, but not in the Category page, we
	      produce a metadata record for the DL
	      with basic information about the entry:
	      country, year, song title, artist,
	      draw-position, placement, and (where available)
	      their total score.
	    </p>
	    <p>
	      Comparable with the problem titles and artist/entrants,
	      we have formulated a SPARQL query that enumerates
	      these missing category entrants:
	      <!--
	      We took the opportunity to add in further fields: Performing Position, Placement, Voting Total, thumbnail flag image.


	      An unintended side-affect of this is that we have also been able to expand
	      -->

	      
	      <ul>
		<li>
		  <a href="sites/{$site_name}/collect/{$collName}/prepare/problem-lod-lists/dbpedia-problem-category-in-year.html">Problem Category pages (some countries not listed in a given year despite competing)</a>
		</li>
	      </ul>
	    </p>

	    <h3>This all culminates in ...</h3>

	    
	    <p>
	      All this work is put together and run through the <i>./PREPARE.sh</i> script.
	      The outcome of this is
		a set of source documents
	      that can be imported into the digital library collectcion.
	      It is instructive to run through the various steps to the prepare script
	      and learn how it operates.  For TLDR users out there, we have packaged
	      up the output from running the prepare script as:
	      build 
	      <ul>
		<li>
		  <a href="sites/{$site_name}/collect/{$collName}/import.tar.gz">
		    import.tar.gz
		  </a>
		</li>
	      </ul>
	      
	    </p>
	    
	  </div>
	  <gsf:script>
	    $('#dl-tech-show-more').showMore({
	        minheight: 0,
		buttontxtmore:"show more ...",
		buttontxtless:"... show less"
	      });
	  </gsf:script>


	  <div>
	    <h2>The Gory Details</h2>
<!--
	      <p>	      
		The resulting SPARQL query result set (JSON format
		selected for output) is then ingested into a Greenstone
		DL collection, and used in a variety of ways.  For now
		an (admittedly cryptic) list of technical steps that
		were developed and/or deployed to provide the
		functionality encountered in interacting with this site.
		
		<ul>
		  <li>New SPARQL plugin for <i>download_from.pl</i> developed, used in GLI to enter the above query</li>
		  <li>New SPARQL <i>Document Processing</i> plugin developed</li>
		  <li>Greenstone3 Apache Jena Triple Store Extension activated</li>
		  <li>SGVizler used to display Google Visualizations such as the pie-chart above.</li>
		  <li>Metadata in document view enhanced through Greenstone Format Statements micro-data</li>
		  <li>Custom <i>interface</i> developed</li>
		</ul>
	      </p>
-->	    
	      <p>
		Viewing the
		<a download="collectionConfig.xml"
	           href="sites/{$site_name}/collect/{$collName}/etc/collectionConfig.xml">collection
		configuration file</a> provides a good insight into how
		all of these technical aspects are brought together.		
	      </p>
	      
	      <p>
		Full disclosure as to how the collection all ticks is
		provided through our Subversion repository.  Topping up
		our
		<a href="https//trac.greenstone.org/browser/main/trunk/greenstone3">Greenstone3
		code base</a> we have:
		
		<ul>
		  <li>The site: <a href="https://trac.greenstone.org/browser/main/trunk/model-sites-dev/eurovision-lod">eurovision-lod</a></li>
		  <li>The interface: <a href="https://trac.greenstone.org/browser/main/trunk/model-interfaces-dev/eurovision-lod">eurovision-lod</a></li>
		  <li>The triplestore extension: <a href="https://trac.greenstone.org/browser/gs2-extensions/apache-jena/trunk/src">apache-jena</a></li>
		</ul>
			
	      </p>

	  </div>
	  
<!--	  
	  <div id="technicaldev-turnstyle" style="margin-top: 12px;">
	    <div class="turnstyle-header" style="background-image: none; background-color: hsl(195, 47%, 35%);">
	      DL Technical Development
	    </div>

	    <div style="display: none; padding-left: 6px; padding-top: 6px; margin-left: 2px; margin-right: 2px; border-left: white solid 1px; border-right: white solid 1px; border-bottom: white solid 1px;">
	      <p>
		In terms of how this collection was developed using the
		Greenstone DL architecture, the starting point is the
		formulation of a SPARQL query to retrieve from DBpedia
		entries about all the entrants in the contest over the
		years:
	      
	      </p>
	      
	    </div>
	  </div>
	  
	  <script>
	    <xsl:text disable-output-escaping="yes">
              $(function(){
                transformToTurnstyleBlock("technicaldev");
              });
	    </xsl:text>
	  </script>
-->

<!--
	  <div id="LOD-turnstyle" style="margin-top: 12px;">
	    <div class="turnstyle-header" style="background-image: none; background-color: hsl(195, 47%, 35%);">
	      Linked Open Data
	    </div>

	    <div style="display: none; padding-left: 6px; padding-top: 6px; margin-left: 2px; margin-right: 2px; border-left: white solid 1px; border-right: white solid 1px; border-bottom: white solid 1px;">


	      <h2>Eurovision LOD SPARQL Endpoints</h2>
	      <p>
		The source data can be access vis the DBpedia SPARQL endpoint.  The ingested,
		data (with correction) is available through the collection's local
		SPARQL endpoint:
		<ul>
		  <li>
		    <a href="https://dbpedia.org/sparql/">DBpedia's SPARQL endpoint</a>
		  </li>
		  <li>
		    <a href="{$library_name}/collection/{$collName}/page/sparql">DL's (local) SPARQL endpoint</a>
		  </li>
		</ul>
	      </p>
	      
	      <h2>Eurovision LOD Errata</h2>
	    </div>
	  </div>
	  
	  <script>
	    <xsl:text disable-output-escaping="yes">
              $(function(){
                transformToTurnstyleBlock("LOD");
              });
	    </xsl:text>
	  </script>
-->

<!--
	  <div id="voting-turnstyle" style="margin-top: 12px;">
	    <div class="turnstyle-header" style="background-image: none; background-color: hsl(195, 47%, 35%);">
	      Voting Data
	    </div>

	    <div style="display: none; padding-left: 6px; padding-top: 6px; margin-left: 2px; margin-right: 2px; border-left: white solid 1px; border-right: white solid 1px; border-bottom: white solid 1px;">
	      <p>
		The Voting data used in this collection is sourced from the Kaggle, which in turn
		is derived from work available through Data Graver:
		<ul>
		  <li><a href="https://www.kaggle.com/datagraver/eurovision-song-contest-scores-19752019">Kaggle Eurovision Voting dataset 1975-2019</a></li>
		  <li><a href="https://data.world/datagraver/eurovision-song-contest-scores-1975-2019">Data Graver</a></li>
		  <li><a href="https://docs.google.com/spreadsheets/d/1veXpiF54hQGP4OVuf1xjowumIe8HUOhI/edit#gid=528591420">Google Spreadsheet (internal use only)</a></li>
		  
		</ul>
	      </p>
	    </div>	  
	  </div>

	  <script>
	    <xsl:text disable-output-escaping="yes">
              $(function(){
                transformToTurnstyleBlock("voting");
              });
	    </xsl:text>
	  </script>

-->
	  
	</div>

  </xsl:template>
	

</xsl:stylesheet>  

